#ifndef __LUT_H__
#define __LUT_H__

 template <int LBound, int UBound, class TypeResult, class TypeArg>
 class LUT_function
 {
 public:
    explicit LUT_function (TypeResult (*f) (TypeArg), double coeff = 1)
    {
        lut = lut_array - LBound;
        for (int i = LBound; i <= UBound; i++)
        { 
            lut[i] = f(coeff * i); 
        }
    }
    
	  const TypeResult & operator()(int i) const
    { 
        return lut[i];
    } 

 private: 
   TypeResult lut_array[UBound - LBound + 1];
   TypeResult * lut; 
}; 

#endif
