/** @file chaincmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CHAINCMDLINE_H
#define CHAINCMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "chain"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "chain"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "v1.6"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * statistic_arg;	/**< @brief statistical test (default='outlier').  */
  char * statistic_orig;	/**< @brief statistical test original value given at command line.  */
  const char *statistic_help; /**< @brief statistical test help description.  */
  #if defined(HAVE_LONG_LONG) || defined(HAVE_LONG_LONG_INT)
  long long int steps_arg;	/**< @brief do 2^n steps.  */
  #else
  long steps_arg;	/**< @brief do 2^n steps.  */
  #endif
  char * steps_orig;	/**< @brief do 2^n steps original value given at command line.  */
  const char *steps_help; /**< @brief do 2^n steps help description.  */
  #if defined(HAVE_LONG_LONG) || defined(HAVE_LONG_LONG_INT)
  long long int int_steps_arg;	/**< @brief do int_steps steps.  */
  #else
  long int_steps_arg;	/**< @brief do int_steps steps.  */
  #endif
  char * int_steps_orig;	/**< @brief do int_steps steps original value given at command line.  */
  const char *int_steps_help; /**< @brief do int_steps steps help description.  */
  char * filename_arg;	/**< @brief name of district file.  */
  char * filename_orig;	/**< @brief name of district file original value given at command line.  */
  const char *filename_help; /**< @brief name of district file help description.  */
  #if defined(HAVE_LONG_LONG) || defined(HAVE_LONG_LONG_INT)
  long long int period_arg;	/**< @brief 2^d is period for output (default=40).  */
  #else
  long period_arg;	/**< @brief 2^d is period for output (default=40).  */
  #endif
  char * period_orig;	/**< @brief 2^d is period for output original value given at command line.  */
  const char *period_help; /**< @brief 2^d is period for output help description.  */
  int only_end_flag;	/**< @brief only output final results (default=on).  */
  const char *only_end_help; /**< @brief only output final results help description.  */
  int variance_flag;	/**< @brief report variance statistics (default=off).  */
  const char *variance_help; /**< @brief report variance statistics help description.  */
  int median_mean_flag;	/**< @brief report median/mean test statistics (default=off).  */
  const char *median_mean_help; /**< @brief report median/mean test statistics help description.  */
  int seat_slide_flag;	/**< @brief report seat-slide test statistics (default=off).  */
  const char *seat_slide_help; /**< @brief report seat-slide test statistics help description.  */
  int seat_thresh_flag;	/**< @brief report seat-thresh test statistics (default=off).  */
  const char *seat_thresh_help; /**< @brief report seat-thresh test statistics help description.  */
  float slideSD_arg;	/**< @brief SD for seatslide gaussian (default='.04').  */
  char * slideSD_orig;	/**< @brief SD for seatslide gaussian original value given at command line.  */
  const char *slideSD_help; /**< @brief SD for seatslide gaussian help description.  */
  float slideMu_arg;	/**< @brief mean shift (default='.5').  */
  char * slideMu_orig;	/**< @brief mean shift original value given at command line.  */
  const char *slideMu_help; /**< @brief mean shift help description.  */
  int maxseats_arg;	/**< @brief max seats for seatthresh (default='0').  */
  char * maxseats_orig;	/**< @brief max seats for seatthresh original value given at command line.  */
  const char *maxseats_help; /**< @brief max seats for seatthresh help description.  */
  int efficiency_gap_flag;	/**< @brief report efficiency gap test statistics (default=off).  */
  const char *efficiency_gap_help; /**< @brief report efficiency gap test statistics help description.  */
  int seats_flag;	/**< @brief report seat count test statistics (default=off).  */
  const char *seats_help; /**< @brief report seat count test statistics help description.  */
  int histogram_flag;	/**< @brief output seat count histogram [HEURISTIC] (default=off).  */
  const char *histogram_help; /**< @brief output seat count histogram [HEURISTIC] help description.  */
  int graph_flag;	/**< @brief output vote share snapshot (default=off).  */
  const char *graph_help; /**< @brief output vote share snapshot help description.  */
  int* freeze_arg;	/**< @brief list of districts to leave unchanged (e.g., for possible M/M districts).  */
  char ** freeze_orig;	/**< @brief list of districts to leave unchanged (e.g., for possible M/M districts) original value given at command line.  */
  unsigned int freeze_min; /**< @brief list of districts to leave unchanged (e.g., for possible M/M districts)'s minimum occurreces */
  unsigned int freeze_max; /**< @brief list of districts to leave unchanged (e.g., for possible M/M districts)'s maximum occurreces */
  const char *freeze_help; /**< @brief list of districts to leave unchanged (e.g., for possible M/M districts) help description.  */
  int counties_flag;	/**< @brief preserve any counties currently belonging to a unique district (default=off).  */
  const char *counties_help; /**< @brief preserve any counties currently belonging to a unique district help description.  */
  int county_traversals_flag;	/**< @brief preserve max number of county traversals (default=off).  */
  const char *county_traversals_help; /**< @brief preserve max number of county traversals help description.  */
  int muni_flag;	/**< @brief preserve preserved municipalities (default=off).  */
  const char *muni_help; /**< @brief preserve preserved municipalities help description.  */
  int loose_munis_flag;	/**< @brief Allow isolated muni swaps (default=off).  */
  const char *loose_munis_help; /**< @brief Allow isolated muni swaps help description.  */
  int precincts_flag;	/**< @brief threshold number of split precincts (default=off).  */
  const char *precincts_help; /**< @brief threshold number of split precincts help description.  */
  double cut_slack_arg;	/**< @brief perim threshold multiplier for precinct cuts (default='2').  */
  char * cut_slack_orig;	/**< @brief perim threshold multiplier for precinct cuts original value given at command line.  */
  const char *cut_slack_help; /**< @brief perim threshold multiplier for precinct cuts help description.  */
  double poperror_arg;	/**< @brief population percent error allowed (default='.051').  */
  char * poperror_orig;	/**< @brief population percent error allowed original value given at command line.  */
  const char *poperror_help; /**< @brief population percent error allowed help description.  */
  int lowerpop_arg;	/**< @brief lower population limit.  */
  char * lowerpop_orig;	/**< @brief lower population limit original value given at command line.  */
  const char *lowerpop_help; /**< @brief lower population limit help description.  */
  int upperpop_arg;	/**< @brief upper population limit.  */
  char * upperpop_orig;	/**< @brief upper population limit original value given at command line.  */
  const char *upperpop_help; /**< @brief upper population limit help description.  */
  float perimeter_arg;	/**< @brief districting perimeter threshold.  */
  char * perimeter_orig;	/**< @brief districting perimeter threshold original value given at command line.  */
  const char *perimeter_help; /**< @brief districting perimeter threshold help description.  */
  float polsby_popper_arg;	/**< @brief Polsby-Popper compactness threshold.  */
  char * polsby_popper_orig;	/**< @brief Polsby-Popper compactness threshold original value given at command line.  */
  const char *polsby_popper_help; /**< @brief Polsby-Popper compactness threshold help description.  */
  float L1_compactness_arg;	/**< @brief threshold for sum of Polsby-Popper values.  */
  char * L1_compactness_orig;	/**< @brief threshold for sum of Polsby-Popper values original value given at command line.  */
  const char *L1_compactness_help; /**< @brief threshold for sum of Polsby-Popper values help description.  */
  float L2_compactness_arg;	/**< @brief threshold for L2 norm of Polsby-Popper values.  */
  char * L2_compactness_orig;	/**< @brief threshold for L2 norm of Polsby-Popper values original value given at command line.  */
  const char *L2_compactness_help; /**< @brief threshold for L2 norm of Polsby-Popper values help description.  */
  float Lh_compactness_arg;	/**< @brief threshold for L-1/2 norm of Polsby-Popper values.  */
  char * Lh_compactness_orig;	/**< @brief threshold for L-1/2 norm of Polsby-Popper values original value given at command line.  */
  const char *Lh_compactness_help; /**< @brief threshold for L-1/2 norm of Polsby-Popper values help description.  */
  int incumbents_flag;	/**< @brief protect protected incumbents (default=off).  */
  const char *incumbents_help; /**< @brief protect protected incumbents help description.  */
  char * inputsvg_filename_arg;	/**< @brief filename of svg input.  */
  char * inputsvg_filename_orig;	/**< @brief filename of svg input original value given at command line.  */
  const char *inputsvg_filename_help; /**< @brief filename of svg input help description.  */
  char * svg_filename_arg;	/**< @brief svg filename (default='districting').  */
  char * svg_filename_orig;	/**< @brief svg filename original value given at command line.  */
  const char *svg_filename_help; /**< @brief svg filename help description.  */
  char * geounit_filename_arg;	/**< @brief geounit filename (default='OutputPA').  */
  char * geounit_filename_orig;	/**< @brief geounit filename original value given at command line.  */
  const char *geounit_filename_help; /**< @brief geounit filename help description.  */
  int svg_firstline_arg;	/**< @brief first rgb line of input.svg (default='4').  */
  char * svg_firstline_orig;	/**< @brief first rgb line of input.svg original value given at command line.  */
  const char *svg_firstline_help; /**< @brief first rgb line of input.svg help description.  */
  int stages_flag;	/**< @brief output files for intermediate stages (default=off).  */
  const char *stages_help; /**< @brief output files for intermediate stages help description.  */
  int flip_flag;	/**< @brief flip A/B party correspondence (default=off).  */
  const char *flip_help; /**< @brief flip A/B party correspondence help description.  */
  int threads_arg;	/**< @brief number of threads to use (default='32').  */
  char * threads_orig;	/**< @brief number of threads to use original value given at command line.  */
  const char *threads_help; /**< @brief number of threads to use help description.  */
  int seed_arg;	/**< @brief seed offset (for benchmarking) (default='0').  */
  char * seed_orig;	/**< @brief seed offset (for benchmarking) original value given at command line.  */
  const char *seed_help; /**< @brief seed offset (for benchmarking) help description.  */
  int benchmark_arg;	/**< @brief benchmark over different seeds.  */
  char * benchmark_orig;	/**< @brief benchmark over different seeds original value given at command line.  */
  const char *benchmark_help; /**< @brief benchmark over different seeds help description.  */
  char * benchfile_arg;	/**< @brief benchmark filename (default='benchmark').  */
  char * benchfile_orig;	/**< @brief benchmark filename original value given at command line.  */
  const char *benchfile_help; /**< @brief benchmark filename help description.  */
  int debug_level_arg;	/**< @brief debugging output level (default='0').  */
  char * debug_level_orig;	/**< @brief debugging output level original value given at command line.  */
  const char *debug_level_help; /**< @brief debugging output level help description.  */
  int max_munis_arg;	/**< @brief maximum municipality number (default='2000').  */
  char * max_munis_orig;	/**< @brief maximum municipality number original value given at command line.  */
  const char *max_munis_help; /**< @brief maximum municipality number help description.  */
  float muni_eps_arg;	/**< @brief precision threshold for muni intersections (default='.01').  */
  char * muni_eps_orig;	/**< @brief precision threshold for muni intersections original value given at command line.  */
  const char *muni_eps_help; /**< @brief precision threshold for muni intersections help description.  */
  double compact_lambda_arg;	/**< @brief lambda for compactness (MH).  */
  char * compact_lambda_orig;	/**< @brief lambda for compactness (MH) original value given at command line.  */
  const char *compact_lambda_help; /**< @brief lambda for compactness (MH) help description.  */
  double pop_lambda_arg;	/**< @brief lambda for population (MH).  */
  char * pop_lambda_orig;	/**< @brief lambda for population (MH) original value given at command line.  */
  const char *pop_lambda_help; /**< @brief lambda for population (MH) help description.  */
  double off_lambda_arg;	/**< @brief lambda offset (default='0').  */
  char * off_lambda_orig;	/**< @brief lambda offset original value given at command line.  */
  const char *off_lambda_help; /**< @brief lambda offset help description.  */
  int steplength_arg;	/**< @brief exponent of length between measurements (default='0').  */
  char * steplength_orig;	/**< @brief exponent of length between measurements original value given at command line.  */
  const char *steplength_help; /**< @brief exponent of length between measurements help description.  */
  double win_thresh_arg;	/**< @brief vote shift (default='.5').  */
  char * win_thresh_orig;	/**< @brief vote shift original value given at command line.  */
  const char *win_thresh_help; /**< @brief vote shift help description.  */
  int splits_arg;	/**< @brief max precinct splits.  */
  char * splits_orig;	/**< @brief max precinct splits original value given at command line.  */
  const char *splits_help; /**< @brief max precinct splits help description.  */
  int testsuite_flag;	/**< @brief testsuite (default=off).  */
  const char *testsuite_help; /**< @brief testsuite help description.  */
  int doubling_rhos_flag;	/**< @brief doubling rho difference pattern (default=off).  */
  const char *doubling_rhos_help; /**< @brief doubling rho difference pattern help description.  */
  int num_rhos_arg;	/**< @brief number of rho rows (default='1').  */
  char * num_rhos_orig;	/**< @brief number of rho rows original value given at command line.  */
  const char *num_rhos_help; /**< @brief number of rho rows help description.  */
  float alpha_mult_arg;	/**< @brief alpha multiplier (default='3').  */
  char * alpha_mult_orig;	/**< @brief alpha multiplier original value given at command line.  */
  const char *alpha_mult_help; /**< @brief alpha multiplier help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int statistic_given ;	/**< @brief Whether statistic was given.  */
  unsigned int steps_given ;	/**< @brief Whether steps was given.  */
  unsigned int int_steps_given ;	/**< @brief Whether int_steps was given.  */
  unsigned int filename_given ;	/**< @brief Whether filename was given.  */
  unsigned int period_given ;	/**< @brief Whether period was given.  */
  unsigned int only_end_given ;	/**< @brief Whether only-end was given.  */
  unsigned int variance_given ;	/**< @brief Whether variance was given.  */
  unsigned int median_mean_given ;	/**< @brief Whether median_mean was given.  */
  unsigned int seat_slide_given ;	/**< @brief Whether seat_slide was given.  */
  unsigned int seat_thresh_given ;	/**< @brief Whether seat_thresh was given.  */
  unsigned int slideSD_given ;	/**< @brief Whether slideSD was given.  */
  unsigned int slideMu_given ;	/**< @brief Whether slideMu was given.  */
  unsigned int maxseats_given ;	/**< @brief Whether maxseats was given.  */
  unsigned int efficiency_gap_given ;	/**< @brief Whether efficiency_gap was given.  */
  unsigned int seats_given ;	/**< @brief Whether seats was given.  */
  unsigned int histogram_given ;	/**< @brief Whether histogram was given.  */
  unsigned int graph_given ;	/**< @brief Whether graph was given.  */
  unsigned int freeze_given ;	/**< @brief Whether freeze was given.  */
  unsigned int counties_given ;	/**< @brief Whether counties was given.  */
  unsigned int county_traversals_given ;	/**< @brief Whether county-traversals was given.  */
  unsigned int muni_given ;	/**< @brief Whether muni was given.  */
  unsigned int loose_munis_given ;	/**< @brief Whether loose_munis was given.  */
  unsigned int precincts_given ;	/**< @brief Whether precincts was given.  */
  unsigned int cut_slack_given ;	/**< @brief Whether cut_slack was given.  */
  unsigned int poperror_given ;	/**< @brief Whether poperror was given.  */
  unsigned int lowerpop_given ;	/**< @brief Whether lowerpop was given.  */
  unsigned int upperpop_given ;	/**< @brief Whether upperpop was given.  */
  unsigned int perimeter_given ;	/**< @brief Whether perimeter was given.  */
  unsigned int polsby_popper_given ;	/**< @brief Whether polsby-popper was given.  */
  unsigned int L1_compactness_given ;	/**< @brief Whether L1-compactness was given.  */
  unsigned int L2_compactness_given ;	/**< @brief Whether L2-compactness was given.  */
  unsigned int Lh_compactness_given ;	/**< @brief Whether Lh-compactness was given.  */
  unsigned int incumbents_given ;	/**< @brief Whether incumbents was given.  */
  unsigned int inputsvg_filename_given ;	/**< @brief Whether inputsvg-filename was given.  */
  unsigned int svg_filename_given ;	/**< @brief Whether svg-filename was given.  */
  unsigned int geounit_filename_given ;	/**< @brief Whether geounit-filename was given.  */
  unsigned int svg_firstline_given ;	/**< @brief Whether svg-firstline was given.  */
  unsigned int stages_given ;	/**< @brief Whether stages was given.  */
  unsigned int flip_given ;	/**< @brief Whether flip was given.  */
  unsigned int threads_given ;	/**< @brief Whether threads was given.  */
  unsigned int seed_given ;	/**< @brief Whether seed was given.  */
  unsigned int benchmark_given ;	/**< @brief Whether benchmark was given.  */
  unsigned int benchfile_given ;	/**< @brief Whether benchfile was given.  */
  unsigned int debug_level_given ;	/**< @brief Whether debug_level was given.  */
  unsigned int max_munis_given ;	/**< @brief Whether max-munis was given.  */
  unsigned int muni_eps_given ;	/**< @brief Whether muni-eps was given.  */
  unsigned int compact_lambda_given ;	/**< @brief Whether compact-lambda was given.  */
  unsigned int pop_lambda_given ;	/**< @brief Whether pop-lambda was given.  */
  unsigned int off_lambda_given ;	/**< @brief Whether off-lambda was given.  */
  unsigned int steplength_given ;	/**< @brief Whether steplength was given.  */
  unsigned int win_thresh_given ;	/**< @brief Whether win_thresh was given.  */
  unsigned int splits_given ;	/**< @brief Whether splits was given.  */
  unsigned int testsuite_given ;	/**< @brief Whether testsuite was given.  */
  unsigned int doubling_rhos_given ;	/**< @brief Whether doubling_rhos was given.  */
  unsigned int num_rhos_given ;	/**< @brief Whether num_rhos was given.  */
  unsigned int alpha_mult_given ;	/**< @brief Whether alpha_mult was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);

extern const char *cmdline_parser_statistic_values[];  /**< @brief Possible values for statistic. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CHAINCMDLINE_H */
